Subject: External interrupt on 460EX

From: Felix Radensky <[email-masked]>
Date: Wed, 15 Oct 2008 16:43:30 +0200

Hi,

I'm running Linux 2.6.26 on custom board based on AMCC 460EX.
I'm trying to catch interrupt generated by CPLD, but without any luck.

The interrupt is connected to GPIO 45. U-Boot (1.3.4) configures this
pin as external interrupt 12 (interrupt 20 in UIC 3). I've added the 
following
entry to board device tree (in opb section)

cpld@2,0 {
    device_type = "cpld";
    interrupts = <20 1>;
    interrupt-parent = <&UIC3>;
};

In my driver I do the following:

    /* Find CPLD node in device tree */
    np = of_find_node_by_type(NULL, "cpld");
    if (!np) {
        printk(KERN_INFO "No CPLD found in device tree\n");
        return -1;
    }

    /* Get and map irq number from device tree */
    cpld_irq = irq_of_parse_and_map(np, 0);
    if (cpld_irq == NO_IRQ) {
        printk(KERN_ERR "irq_of_parse_and_map failed\n");
        of_node_put(np);
        return -ENODEV;
    }

    /* Register CPLD interrupt handler */
    rc = request_irq(cpld_irq, cpld_interrupt,
             IRQF_TRIGGER_LOW, "CPLD", NULL);

And I see this interrupt in /proc/interrups after loading
the driver. However interrupt handler is never invoked,
although hardware guys see that GPIO line goes down
when interrupt is generated.

What am I doing wrong ?

Thanks a lot in advance ?

Felix.